Unit MNK16_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MNK16(N :Integer; var NF :Integer; var I1 :Array of Integer;
                CAB1 :Real; var XE1 :Array of Real;
                var XF :Array of Real; FF :Real; FFE :Real;
                var G :Array of Real; var GE :Array of Real; CG :Real;
                var X :Array of Real; FUN :Proc_F1_MN);

implementation

procedure MNK16(N :Integer; var NF :Integer; var I1 :Array of Integer;
                CAB1 :Real; var XE1 :Array of Real;
                var XF :Array of Real; FF :Real; FFE :Real;
                var G :Array of Real; var GE :Array of Real; CG :Real;
                var X :Array of Real; FUN :Proc_F1_MN);
var
J,I :Integer;
FE,F :Real;
label
_1,_2,_3;
begin
{   BCEHE PAHOCTHOO PAEHTA B TOKE XF  EO OPAOTKA }
for I:=1 to N do
 begin
  if ( I1[I-1] = 0 ) 
   then goto _2;
  for J:=1 to N do
   begin
    if ( I <> J ) 
     then X[J-1] := XF[J-1];
_1:
   end;
  X[I-1] := XF[I-1]+XE1[I-1];
  FE := CAB1;
  FUN(X,F,FE);
  NF := NF+1;
  G[I-1] := (F-FF)/XE1[I-1];
  GE[I-1] := (FE+FFE)/(2*XE1[I-1]);
  X[I-1] := CG*FFE/XE1[I-1];
  if ( X[I-1] > GE[I-1] ) 
   then GE[I-1] := X[I-1];
  if ( Abs(G[I-1]) > GE[I-1] ) 
   then goto _3;
  I1[I-1] := 0;
_2:
  G[I-1] := 0;
_3:
 end;
end;

end.
