{    var   : }
{ N }
Unit MNK6R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MN013_p, MNK16_p, MN015_p, MNKU7_p, MN016_p, MN010_p, MNKU5_p,
MN009_p, MNKP1_p, MNKP0_p, MN012_p;

procedure MNK6R(var XF :Array of Real; var XE :Array of Real;
                var I0 :Array of Integer; var A :Array of Real;
                var B :Array of Real; var N :Integer; FUNC :Proc_F1_MN;
                var FF :Real; var FFE :Real; var UP :Array of Real;
                var RM :Array of Real; var IRM :Array of Integer;
                var W :Integer);

implementation

procedure MNK6R(var XF :Array of Real; var XE :Array of Real;
                var I0 :Array of Integer; var A :Array of Real;
                var B :Array of Real; var N :Integer; FUNC :Proc_F1_MN;
                var FF :Real; var FFE :Real; var UP :Array of Real;
                var RM :Array of Real; var IRM :Array of Integer;
                var W :Integer);
var
W0,KMAX,KP,KP1,IPRINT,I1,M1H,M1F,NM,NXE1,NI1,NP,NXT,NGE,NX,NHPR,K,NF,
   M,NF0,NF1,LM,NPI1,NG,NCI1,NC,NXTI1,NHPRKP,NHPRI1,I :Integer;
EM,CAB1,CG,CAB,EFE,GMAX,QG,Q2G,QP,PG,PMAX,Q2P,HE1,HM,HA,HB,HAE,HBE,HT,
   FT,FTE,HA1,HB1,ETE :Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25;
begin
{   EM-MAKCMAH OPOK ACOTHO BEH }
{   BEECTBEHHO KOHCTAHT; }
EM := 30;
{ HAAA HACTPOKA }
KMAX := Trunc(UP[0]);
KP := Trunc(UP[1]);
KP1 := Trunc(-1.0);
IPRINT := Trunc(UP[2]);
M1H := Trunc(UP[3]);
M1F := Trunc(UP[4]);
CAB1 := UP[5];
CG := UP[6];
NM := Trunc(UP[7]);
CAB := FFE;
NXE1 := 9;
NI1 := 3;
NP := 1;
NXT := 1+N;
NG := 1+2*N;
NGE := 1+3*N;
NX := 1+4*N;
NHPR := 1+5*N;
{   HACTPOKA AKOHEHA }
K := 0;
NF := 0;
_1:
NF := NF+1;
FFE := CAB1;
FUNC(XF,FF,FFE);
EFE := FFE;
if ( CAB1 > FFE ) 
 then FFE := CAB1;
_2:
MN013(IRM[NI1-1],I0,N);
MNK16(N,NF,IRM[NI1-1],CAB1,UP[NXE1-1],XF,FF,FFE,
     RM[NG-1],RM[NGE-1],CG,RM[NX-1],FUNC);
MN015(IRM[NI1-1],GMAX,A,B,XE,XF,RM[NG-1],N);
MNKU7(N,IRM[NI1-1],RM[NG-1],GMAX,QG,Q2G);
M := 0;
if ( Q2G = 0.0 ) 
 then goto _25;
if ( NM = 1 ) 
 then goto _4;
for I:=1 to N do
 begin
  NPI1 := NP+I-1;
  NCI1 := NG+I-1;
_3:
  RM[NPI1-1] := RM[NCI1-1];
 end;
QP := QG;
PG := QP;
goto _5;
_4:
MN016(N,IRM[NI1-1],A,B,XF,RM[NG-1],RM[NP-1],PMAX);
MNKU7(N,IRM[NI1-1],RM[NP-1],PMAX,QP,Q2P);
M := 0;
if ( Q2P = 0.0 ) 
 then goto _25;
_5:
HE1 := Power(10.0,EM/2);
for I:=1 to N do
 begin
  if ( IRM[NI1+I-2] = 0 ) 
   then goto _6;
  NPI1 := NP+I-1;
  RM[NPI1-1] := RM[NPI1-1]/QP;
  HM := UP[NXE1+I-2]/Abs(RM[NP+I-2]);
  HE1 := EMin1(HE1,HM);
  goto _7;
_6:
  NPI1 := NP+I-1;
  RM[NPI1-1] := 0.0;
_7:
 end;
MN010(HA,HB,HAE,HBE,A,B,HE1,XF,UP[NXE1-1],IRM[NI1-1],
     RM[NP-1],N,EM);
M := 1;
if ( HE1 > HB ) 
 then goto _25;
if ( NM = 1 ) 
 then MNKU5(N,IRM[NI1-1],RM[NP-1],RM[NG-1],GMAX,
           PG);
if ( K = 0 ) 
 then HT := EMax1(5*HE1,0.01*PG);
MN009(N,NF0,IRM[NI1-1],RM[NP-1],PG,HA,HB,HE1,CAB1,XF,
     FF,FFE,HT,RM[NXT-1],FT,FTE,HA1,HB1,RM[NX-1],0.5,2.0,0.5,2.0,
     0.0,W0,FUNC);
if ( CAB1 > FTE ) 
 then FTE := CAB1;
NF1 := NF;
NF := NF+NF0;
M := 1;
if ( W0 = 0 ) 
 then goto _25;
if ( HB-HBE > HT ) 
 then goto _9;
NF := NF+1;
HT := HB;
for I:=1 to N do
 begin
  NXTI1 := NXT+I-1;
  NPI1 := NP+I-1;
_8:
  RM[NXTI1-1] := XF[I-1]-HT*RM[NPI1-1];
 end;
FTE := CAB1;
FUNC(RM[NXT-1],FT,FTE);
ETE := FTE;
if ( CAB1 > FTE ) 
 then FTE := CAB1;
_9:
if ( FF-FT > FFE ) 
 then goto _10;
M := 1;
if ( FT-FF >= FFE ) 
 then goto _25;
M := 2;
goto _25;
_10:
K := K+1;
if ( KP = 0 ) 
 then goto _12;
if ( K = 1 ) 
 then goto _11;
if ( KP = KP1 ) 
 then goto _12;
if ( ((K) Mod (KP)) <> 0 ) 
 then goto _12;
_11:
MNKP1(IPRINT,N,NF,NG,K,IRM[NI1-1],XF,UP[NXE1-1],FF,FFE,
     RM[NG-1],RM[NGE-1],RM[NP-1],QG,RM[NHPR-1],1,1);
_12:
for I:=1 to N do
 begin
_13:
  XF[I-1] := RM[NXT+I-2];
 end;
FF := FT;
FFE := FTE;
EFE := ETE;
if ( KP <= 1 ) 
 then goto _15;
I := K-(K div KP)*KP;
if ( I <> 0 ) 
 then goto _14;
NHPRKP := NHPR+KP-1;
RM[NHPRKP-1] := HT;
MNKP1(IPRINT,N,NF,NG,K,IRM[NI1-1],XF,UP[NXE1-1],FF,FFE,
     RM[NG-1],RM[NGE-1],RM[NP-1],QG,RM[NHPR-1],KP,2);
goto _15;
_14:
NHPRI1 := NHPR+I-1;
RM[NHPRI1-1] := HT;
_15:
if ( K < KMAX ) 
 then goto _2;
_16:
IRM[0] := K;
MNK16(N,NF,IRM[NI1-1],CAB1,UP[NXE1-1],XF,FF,FFE,
     RM[NG-1],RM[NGE-1],CG,RM[NX-1],FUNC);
MNKU7(N,IRM[NI1-1],RM[NG-1],1.0,QG,Q2G);
IRM[1] := NF;
if ( KP = 0 ) 
 then goto _17;
MNKP1(IPRINT,N,NF,NG,K,IRM[NI1-1],XF,UP[NXE1-1],FF,FFE,
     RM[NG-1],RM[NGE-1],RM[NP-1],QG,RM[NHPR-1],1,1);
if ( KP < 2 ) 
 then goto _17;
KP1 := K-(K div KP)*KP;
if ( KP1 < 2 ) 
 then goto _17;
KP1 := KP1-1;
MNKP1(IPRINT,N,NF,NG,K,IRM[NI1-1],XF,UP[NXE1-1],FF,FFE,
     RM[NG-1],RM[NGE-1],RM[NP-1],QG,RM[NHPR-1],KP1,2);
_17:
{   PEKPAEHE TEPAOHHOO POECCA }
if ( K-KMAX ) < 0
 then goto _19
 else if ( K-KMAX ) > 0
       then goto _18
       else goto _18;
_18:
W := 4;
goto _24;
_19:
if ( M1H+M1F ) < 0
 then goto _20
 else if ( M1H+M1F ) > 0
       then goto _21
       else goto _20;
_20:
W := 12;
goto _24;
_21:
if ( M1H ) < 0
 then goto _22
 else if ( M1H ) > 0
       then goto _23
       else goto _22;
_22:
W := 1;
goto _24;
_23:
W := 2;
_24:
if ( KP <> 0 ) 
 then MNKP0(IPRINT,W);
exit;
_25:
MN012(M1F,M1H,LM,CAB1,CAB,UP[NXE1-1],XE,M,N);
if ( LM ) < 0
 then goto _16
 else if ( LM ) > 0
       then goto _1
       else goto _16;
end;

end.
