Unit MNKP1_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UtRes1_p;

function MNKP1(IPRINT :Integer; N :Integer; NF :Integer; NG :Integer;
                KIT :Integer; var I1 :Array of Integer;
                var X :Array of Real; var XE :Array of Real; F :Real;
                FE :Real; var G :Array of Real; var GE :Array of Real;
                var P :Array of Real; QG :Real;
                var HPR :Array of Real; KP :Integer;
                W :Integer): String;

implementation

function MNKP1(IPRINT :Integer; N :Integer; NF :Integer; NG :Integer;
                KIT :Integer; var I1 :Array of Integer;
                var X :Array of Real; var XE :Array of Real; F :Real;
                FE :Real; var G :Array of Real; var GE :Array of Real;
                var P :Array of Real; QG :Real;
                var HPR :Array of Real; KP :Integer;
                W :Integer): String;
var
I,_i :Integer;
label
_10,_11,_12;
begin
Result := '';  {   }
{   EAT APYMEHTA,YHK, PAEHTA  TOHOCT X BCEH }
{   EAT HAPABEH CYCKA, MACCBA KCPOBAHHX KOMOHEHT }
{   EAT K-BA TEPA, K-BA BCEH YHK  PAEHTA, }
{   HOPM PAEHTA P W=1; }
{   EAT AA O HAPABEH CYCKA P W=2 }
if ( W = 2 )
 then goto _10;
Result := Result + Format('%s',[
 '********************************************************************************']) + #$0D#$0A;
Result := Result + Format('%s',[
 '   AP.    TO.O AP.    PA.    TO.O P. BEK.CYC.  KC.KOM']) + #$0D#$0A;
Result := Result + #$0D#$0A;
for I:=1 to N do
 begin
  Result := Result + Format('%20.16f %20.16f %20.16f %20.16f %20.16f %5d ',
 [X[I-1],XE[I-1],G[I-1],GE[I-1],P[I-1],I1[I-1]]) + #$0D#$0A;
 end;
Result := Result + #$0D#$0A;
Result := Result + Format('%s',[' -=']);
Result := Result + Format('%20.16f',[F]);
Result := Result + Format('%s',[' TO.O -Y=']);
Result := Result + Format('%20.16f',[FE]);
Result := Result + Format('%s',[' HOPMA P-TA=']);
Result := Result + Format('%20.16f',[QG]);
Result := Result + Format('%s',[' K-BO TEPA']);
Result := Result + Format('%4d',[KIT]);
Result := Result + Format('%s',['  ' + #$0D#$0A + '  B.-A']);
Result := Result + Format('%5d',[NF]);
Result := Result + Format('%s',['  B.P-TA']);
Result := Result + Format('%5d ',[NG]) + #$0D#$0A;
if ( W = 1 )
 then goto _12;
_10:
if ( KP > 4 )
 then goto _11;
Result := Result + Format('%s',[' A O HAPABEH CYCKA ']);
Result := Result + Format('%4d',[KP]);
Result := Result + Format('%s',[' OCEHX TEPA:']);
Result := Result + #$0D#$0A;
for _i:=0 to KP-1 do
 begin
  Result := Result + Format('%20.16f ',[HPR[_i]]);
  if ( ((_i+1) mod 4)=0 )
   then Result := Result + #$0D#$0A;
 end;
Result := Result + #$0D#$0A;
goto _12;
_11:
Result := Result + Format('%s',[' A O HAPABEH CYCKA ']);
Result := Result + Format('%4d',[KP]);
Result := Result + Format('%s',[' OCEHX TEPA:']);
Result := Result + #$0D#$0A;
for I:=1 to 4 do
 begin
  Result := Result + Format('%20.16f ',[HPR[I-1]]) + #$0D#$0A;
 end;
Result := Result + #$0D#$0A;
Result := Result + #$0D#$0A;
for I:=5 to KP do
 begin
  Result := Result + Format('%20.16f ',[HPR[I-1]]) + #$0D#$0A;
 end;
Result := Result + #$0D#$0A;
_12:
UtRes1('mnkp1',Result,True);  {     mnkp1.res }
exit;
end;

end.
