Unit MN010_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MN010(var HA :Real; var HB :Real; var HAE :Real;
                var HBE :Real; var A :Array of Real;
                var B :Array of Real; HE1 :Real;
                var XF :Array of Real; var XE1 :Array of Real;
                var I1 :Array of Integer; var P :Array of Real;
                N :Integer; EM :Real);

implementation

procedure MN010(var HA :Real; var HB :Real; var HAE :Real;
                var HBE :Real; var A :Array of Real;
                var B :Array of Real; HE1 :Real;
                var XF :Array of Real; var XE1 :Array of Real;
                var I1 :Array of Integer; var P :Array of Real;
                N :Integer; EM :Real);
var
I :Integer;
R1,R2,R3 :Real;
label
_1,_2,_3;
begin
{   BCEHE APAMETPOB OHOMEPHO MHMA }
HA := 0.0;
HAE := HE1;
HB := Power(10,EM-2);
HBE := HB;
for I:=1 to N do
 begin
  if ( I1[I-1] = 0 ) 
   then goto _3;
  if ( P[I-1] > 0 ) 
   then goto _2;
  R1 := B[I-1];
  R2 := B[I-1]-XE1[I-1];
  R3 := A[I-1]+XE1[I-1];
_1:
  R1 := (XF[I-1]-R1)/P[I-1];
  R2 := (XF[I-1]-R2)/P[I-1];
  R3 := (XF[I-1]-R3)/P[I-1];
  if ( R3 > HAE ) 
   then HAE := R3;
  if ( R2 < HBE ) 
   then HBE := R2;
  if ( R1 < HB ) 
   then HB := R1;
  goto _3;
_2:
  R1 := A[I-1];
  R2 := A[I-1]+XE1[I-1];
  R3 := B[I-1]-XE1[I-1];
  goto _1;
_3:
 end;
HBE := HB-HBE;
if ( HE1 > HBE ) 
 then HBE := HE1;
end;

end.
