Unit MN016_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MN016(N :Integer; var I1 :Array of Integer;
                var A :Array of Real; var B :Array of Real;
                var XF :Array of Real; var G :Array of Real;
                var P :Array of Real; var PMAX :Real);

implementation

procedure MN016(N :Integer; var I1 :Array of Integer;
                var A :Array of Real; var B :Array of Real;
                var XF :Array of Real; var G :Array of Real;
                var P :Array of Real; var PMAX :Real);
var
I :Integer;
label
_1,_2,_3,_4;
begin
PMAX := 0.0;
for I:=1 to N do
 begin
  if ( I1[I-1] = 0 ) 
   then goto _3;
  if ( G[I-1] > 0.0 ) 
   then goto _1;
  P[I-1] := XF[I-1]-B[I-1];
  goto _2;
_1:
  P[I-1] := XF[I-1]-A[I-1];
_2:
  if ( Abs(P[I-1]) > PMAX ) 
   then PMAX := Abs(P[I-1]);
  goto _4;
_3:
  P[I-1] := 0.0;
_4:
 end;
end;

end.
