Unit MNKU7_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MNKU7(N :Integer; var I1 :Array of Integer;
                var G :Array of Real; GMAX :Real; var QG :Real;
                var Q2G :Real);

implementation

procedure MNKU7(N :Integer; var I1 :Array of Integer;
                var G :Array of Real; GMAX :Real; var QG :Real;
                var Q2G :Real);
var
I :Integer;
label
_1;
begin
{  BCEHE HOPM BEKTOPA G }
Q2G := 0.0;
for I:=1 to N do
 begin
  if ( I1[I-1] = 0 ) 
   then goto _1;
  Q2G := Q2G+(G[I-1]/GMAX)*(G[I-1]/GMAX);
_1:
 end;
Q2G := Q2G*GMAX*GMAX;
QG := Sqrt(Q2G);
end;

end.
